StoreLocator.prototype.extend(StoreLocator.prototype, {
	displayGoogleResults: function(){
		if(typeof google == "undefined"){
			this.loadGoogleMapAPI();
		}else{
			this.renderGoogleMap();
		}
	},
	googleMapAPICallback: function(){
		for(var i = 0; i < EB._block.length; i ++){
			if(EB._block[i].GOOGLEMAP && EB._block[i].status == 2){
				EB._block[i].renderGoogleMap();
			}
		}
	},
	loadGoogleMapAPI: function(){
		if(!this.d("googleAPIJS")){ this.appendJSTag("https://maps.googleapis.com/maps/api/js?" + (this.googleMapKey != "" ? "&key=" + this.googleMapKey + "&" : "") + "callback=StoreLocator.prototype.googleMapAPICallback", "googleAPIJS"); }
	},
	renderGoogleMap: function(){
		this.status = 3;
		this.infoWindowObj = new Array();
		this.mapContainer.style.display = "block";
		var center = null;
		// Loop through Response		
		for(var i = 0; i < this.responseData["Store List"].length; i++){
			// Save Reference to Data
			var data = this.responseData["Store List"][i];
			
			if(center == null){
				// Get Center location
				center = new google.maps.LatLng(data["+latitude"], data["+longitude"]);
			}
			
			
			if(!this.MAP){
				var myOptions = {
					zoom: this.initialZoom,
					center: center,
					mapTypeControl: false,
					scaleControl: false,
					streetViewControl: false,
					overviewMapControl: false,
					disableDefaultUI: true,
					mapTypeId: google.maps.MapTypeId.ROADMAP
				};
				if(this.zoomControl && !this.customZoomControl){
					myOptions.zoomControl = true;
					myOptions.zoomControlOptions = {position: google.maps.ControlPosition[this.zoomControlPosition.split("_")[1] + "_" + this.zoomControlPosition.split("_")[0]], style: google.maps.ZoomControlStyle.SMALL};
				}
				this.MAP = new google.maps.Map(this.mapContainer, myOptions);
			}else{
				this.MAP.setCenter(center);
			}
			var infoWindow = this.renderInfoWindow(data, i);
			this.infoWindowObj[i] = new google.maps.InfoWindow(infoWindow);
			var markerCofig = {
				uid: this.uid,
				poi: i,
				// Declare Marker position
				position: new google.maps.LatLng(data["+latitude"], data["+longitude"]),
				map: this.MAP,
				html: infoWindow
			};
			if(this.numberedMarker || this.customMarker){ markerCofig.icon = this.markerIcon.replace("{n}", (i + 1)); }
			
			this.poi[i] = new google.maps.Marker(markerCofig);
			
			google.maps.event.addListener(this.poi[i], "click", function(){
					var slObj = StoreLocator.prototype.getTargetObject("uid", this.uid);
					if(slObj != null){
						slObj.infoWindowObj[this.poi].setContent(this.html);
						slObj.infoWindowObj[this.poi].open(slObj.MAP, this);
						slObj.infoWindowObj[this.poi].setPosition(this.pointPos);
						EB.userActionCounter(slObj.eventNamePrefix + "_LocationMarkerClicked");
					}
				});
		}
		this.showMap();
	},
	googleDirectionLink: function(address, data){
		return "https://maps.google.com/?daddr=" + address;
	},	
	googleCleanUp: function(){
		for(var i = 0; i < this.poi.length; i++){ this.poi[i].setMap(null); }
		this.mapContainer.style.display = "none";
	},
	panEast: function(){
		var objId = StoreLocator.prototype.getObjectId(this);
		var slObj = objId == null ? this : StoreLocator.prototype.getTargetObject("uid", objId.split("Pan")[0]);
		slObj.MAP.panBy(slObj.panDistance, 0);
	},
	panWest: function(){
		var objId = StoreLocator.prototype.getObjectId(this);
		var slObj = objId == null ? this : StoreLocator.prototype.getTargetObject("uid", objId.split("Pan")[0]);
		slObj.MAP.panBy(0 - slObj.panDistance, 0);
	},
	panSouth: function(){
		var objId = StoreLocator.prototype.getObjectId(this);
		var slObj = objId == null ? this : StoreLocator.prototype.getTargetObject("uid", objId.split("Pan")[0]);
		slObj.MAP.panBy(0, slObj.panDistance);
	},
	panNorth: function(){
		var objId = StoreLocator.prototype.getObjectId(this);
		var slObj = objId == null ? this : StoreLocator.prototype.getTargetObject("uid", objId.split("Pan")[0]);
		slObj.MAP.panBy(0, 0 - slObj.panDistance);
	},
	zoomIn: function(){
		var objId = StoreLocator.prototype.getObjectId(this);
		var slObj = objId == null ? this : StoreLocator.prototype.getTargetObject("uid", objId.split("Zoom")[0]);	
		slObj.MAP.setZoom(slObj.MAP.zoom < 21 ? slObj.MAP.zoom + 1 : 21);
	},
	zoomOut: function(){
		var objId = StoreLocator.prototype.getObjectId(this);
		var slObj = objId == null ? this : StoreLocator.prototype.getTargetObject("uid", objId.split("Zoom")[0]);	
		slObj.MAP.setZoom(slObj.MAP.zoom > 1 ? slObj.MAP.zoom - 1 : 1);
	},
	googleModuleLoaded: function(){
		return true;
	}	
}, "StoreLocator.prototype.mapModuleLoaded", "google");