StoreLocator.prototype.extend(StoreLocator.prototype, {
	displayListResults: function(){
		if(this.isiOS || this.isAndroid){
			var osVersion = this.ua.match(/os \d|android \d/i);
			if(osVersion != null){ osVersion = osVersion.toString().replace(/os /i, "").replace(/android /i, ""); }
			if(osVersion == null || (this.isiOS && osVersion <= 4) || (this.isAndroid && osVersion <= 2)){ this.customScrollbar = true; }
			this.scrollbarWidth = 0;
		}
		if(this.customScrollbar && typeof jQuery == "undefined"){
			this.loadListAPI();
		}else{
			this.renderList();
		}
	},
	listAPICallback: function(){
		for(var i = 0; i < EB._block.length; i ++){
			if(!EB._block[i].useMap && EB._block[i].status == 2){
				clearInterval(EB._block[i].apiLoaderTimer);
				EB._block[i].renderList();
			}
		}
	},
	loadListAPI: function(){
		if(!this.d("jQueryJS")){ this.appendJSTag("https://ajax.googleapis.com/ajax/libs/jquery/1.9.1/jquery.min.js", "jQueryJS"); }
		this.apiLoaderTimer = setInterval(function(){
			if(typeof jQuery != "undefined"){
				if(!StoreLocator.prototype.d("tinyScrollbarJS")){ StoreLocator.prototype.appendJSTag("store_locator/modules/jquery.tinyscrollbar.min.js", "tinyScrollbarJS"); }
				if(typeof jQuery.tiny != "undefined"){ StoreLocator.prototype.listAPICallback(); }
			}
		}, 50);
	},
	renderList: function(){
		if(!this.d(this.uid + "ListContainer")){
			var _stage = document.createElement("div");
			_stage.id = this.uid + "ListContainer";
			_stage.style.width = this.config.width + "px";
			_stage.style.height = this.config.height + "px";
			if(!this.customScrollbar){ _stage.style.overflowY = "scroll"; }
			this.resultContainer.appendChild(_stage);
		}else{
				var _stage = this.d(this.uid + "ListContainer");
		}
		if(this.customScrollbar){
			if(!this.d(this.uid + "Overview")){
				var tinyScrollStyle = "." + this.uid + ".viewport { width: " + (this.config.width - this.scrollbarWidth) + "px; height: " + this.config.height + "px; overflow: hidden; position: relative; }";
				tinyScrollStyle += "." + this.uid + ".overview { list-style: none; position: absolute; left: 0; top: 0; }";
				tinyScrollStyle += "." + this.uid + ".thumb .end, ." + this.uid + ".thumb { background-color: " + this.scrollbarHandlerColor + "; }";
				tinyScrollStyle += "." + this.uid + ".scrollbar { position: relative; float: right; width: " + this.scrollbarWidth + "px; }";
				tinyScrollStyle += "." + this.uid + ".track { background-color: " + this.scrollbarTrackColor + "; height: 100%; width:" + this.scrollbarWidth + "px; position: relative; padding: 0; }";
				tinyScrollStyle += "." + this.uid + ".thumb { width: " + this.scrollbarWidth + "px; cursor: pointer; overflow: hidden; position: absolute; top: 0; }";
				tinyScrollStyle += "." + this.uid + ".thumb .end { overflow: hidden; height: 5px; width: " + (this.scrollbarWidth - 2) + "px; }";
				tinyScrollStyle += "." + this.uid + ".disable{ display: none; }";
				tinyScrollStyle += "." + this.uid + ".noSelect { user-select: none; -o-user-select: none; -moz-user-select: none; -khtml-user-select: none; -webkit-user-select: none; }";

				var _tinyScrollstyle = document.createElement("style");
				_tinyScrollstyle.innerHTML = tinyScrollStyle;
				this.container.appendChild(_tinyScrollstyle);

				var _scrollbar = document.createElement("div");
				_scrollbar.className = this.uid + " scrollbar";
				_stage.appendChild(_scrollbar);

				var _scrolltrack = document.createElement("div");
				_scrolltrack.className = this.uid + " track";
				_scrollbar.appendChild(_scrolltrack);

				var _scrollthumb = document.createElement("div");
				_scrollthumb.className = this.uid + " thumb";
				_scrolltrack.appendChild(_scrollthumb);

				var _scrollend = document.createElement("div");
				_scrollend.className = this.uid + " end";
				_scrollthumb.appendChild(_scrollend);

				var _viewport = document.createElement("div");
				_viewport.className = this.uid + " viewport";
				_stage.appendChild(_viewport);

				var _overview = document.createElement("div");
				_overview.id = this.uid + "Overview";
				_overview.className = this.uid + " overview";
				_viewport.appendChild(_overview);
			}
			this.d(this.uid + "Overview").innerHTML = "";
		}else{
			this.d(this.uid + "ListContainer").innerHTML = "";
		}

		// Loop through Response Data
		for(var i = 0; i < this.responseData["Store List"].length; i++){
			// Save Reference to Store Location
			var data = this.responseData["Store List"][i];
			this.poi[i] = document.createElement("div");
			this.poi[i].innerHTML = this.renderInfoWindow(data, i);
			this.d(this.uid + (this.customScrollbar ? "Overview" : "ListContainer")).appendChild(this.poi[i]);
		}

		if(this.customScrollbar){ jQuery("#" + this.uid + "ListContainer").tinyscrollbar({invertscroll:true}); }

		this.showMap();
	},
	mapquestDirectionLink: function(address, data){
		return "http://www.mapquest.com/?le=t&q=" + address + "&maptype=map&vs=map";
	},
	googleDirectionLink: function(address, data){
		return "http://maps.google.com/?daddr=" + address;
	},
	listCleanUp: function(){
		this.d(this.uid + "ListContainer").innerHTML = "";
	},
	showList: function(){
		this.showMap();
	},
	hideList: function(){
		this.hideMap();
	},
	collapseList: function(){
		this.collapseMap();
	},
	listModuleLoaded: function(){
		return true;
	}
}, "StoreLocator.prototype.mapModuleLoaded", "list");
