StoreLocator.prototype.extend(StoreLocator.prototype, {
	displayMapquestResults: function(){
		if(typeof MQA == "undefined"){
			this.loadMapguestAPI();
		}else{
			this.renderMapquestMap();
		}
	},
	mapquestAPICallback: function(){
		for(var i = 0; i < EB._block.length; i ++){
			if(EB._block[i].MAPQUESTMAP && EB._block[i].status == 2){
				clearInterval(EB._block[i].apiLoaderTimer);
				EB._block[i].renderMapquestMap();
			}
		}
	},
	loadMapguestAPI: function(){
		// Build MapQuest API query string
		if(!this.d("mapQuestAPIJS")){ this.appendJSTag("https://www.mapquestapi.com/sdk/js/v7.0.s/mqa.toolkit.js?key=" + this.MapQuestApiKey, "mapQuestAPIJS"); }
		this.apiLoaderTimer = setInterval(function(){
			if(typeof MQA != "undefined"){ StoreLocator.prototype.mapquestAPICallback(); }
		}, 50);
	},
	renderMapquestMap: function(){
		this.status = 3;
		this.mapContainer.style.display = "block";
		if(this.config.hasOwnProperty("options")){
			if(!this.config.options.hasOwnProperty("numberedMarker")){ this.numberedMarker = true; }
		}
		this.panEWDistance = Math.floor(this.panDistance / this.config.width * 100);
		this.panNSDistance = Math.floor(this.panDistance / this.config.height * 100);

		this.pois = new MQA.ShapeCollection();
		this.pois.collectionName = this.uid + "MQPOIColl";
		var centerPoi = null;
		// Loop through Response Data
		for(var i = 0; i < this.responseData["Store List"].length; i++){
			// Save Reference to Store Location
			var data = this.responseData["Store List"][i];
			// Save Point of interest
			this.poi[i] = new MQA.Poi({ lat : data["+latitude"], lng : data["+longitude"] });
			// Get Center location
			if(centerPoi == null){ centerPoi = new MQA.LatLng(data["+latitude"], data["+longitude"]);}
			if(this.numberedMarker || this.customMarker){ this.poi[i].setIcon(new MQA.Icon(this.markerIcon.replace("{n}", (i + 1)), 20, 29)); }
			var infoWindow = this.renderInfoWindow(data, i);
			this.poi[i].setInfoContentHTML(infoWindow);
			this.poi[i]._slDefaultInfoTag = infoWindow;
			this.poi[i]._slEventNamePrefix = this.eventNamePrefix;
			this.pois.add(this.poi[i]);
			MQA.EventManager.addListener(this.poi[i], (this.isiOS || this.isAndroid ? "touchstart" : "click"), function(e){
				e.srcObject.infoContentHTML = e.srcObject._slDefaultInfoTag;
				EB.userActionCounter(e.srcObject._slEventNamePrefix + "_LocationMarkerClicked");
			});
			if(!this.mouseHoverInfo){
				MQA.EventManager.addListener(this.poi[i], "mouseover", function(e){
					e.srcObject.infoContentHTML = "";
				});
			}
		}
		var mapOptions = {
		  elt: this.mapContainer
		};
		if(!this.MAP){
			this.MAP = new MQA.TileMap(mapOptions);
			if(this.zoomControl && !this.customZoomControl){
				slMQObj = this;
				MQA.withModule("smallzoom", function(){
					slMQObj.MAP.addControl(
						new MQA.SmallZoom(),
						new MQA.MapCornerPlacement(MQA.MapCorner[slMQObj.zoomControlPosition], new MQA.Size(5,5))
					);
				});
			}
		}
		this.MAP.addShapeCollection(this.pois);
		this.MAP.setZoomLevel(this.initialZoom);
		this.MAP.setCenter(centerPoi);
		this.showMap();
	},
	mapquestDirectionLink: function(address, data){
		return "http://www.mapquest.com/?le=t&q=" + address + "&maptype=map&vs=map";
	},
	mapquestCleanUp: function(){
		this.MAP.removeShapeCollection(this.pois.collectionName);
		this.mapContainer.style.display = "none";
	},
	panEast: function(){
		var objId = StoreLocator.prototype.getObjectId(this);
		var slObj = objId == null ? this : StoreLocator.prototype.getTargetObject("uid", objId.split("Pan")[0]);
		slObj.MAP.panEast(slObj.panEWDistance);
	},
	panWest: function(){
		var objId = StoreLocator.prototype.getObjectId(this);
		var slObj = objId == null ? this : StoreLocator.prototype.getTargetObject("uid", objId.split("Pan")[0]);
		slObj.MAP.panWest(slObj.panEWDistance);
	},
	panSouth: function(){
		var objId = StoreLocator.prototype.getObjectId(this);
		var slObj = objId == null ? this : StoreLocator.prototype.getTargetObject("uid", objId.split("Pan")[0]);
		slObj.MAP.panSouth(slObj.panNSDistance);
	},
	panNorth: function(){
		var objId = StoreLocator.prototype.getObjectId(this);
		var slObj = objId == null ? this : StoreLocator.prototype.getTargetObject("uid", objId.split("Pan")[0]);
		slObj.MAP.panNorth(slObj.panNSDistance);
	},
	zoomIn: function(){
		var objId = StoreLocator.prototype.getObjectId(this);
		var slObj = objId == null ? this : StoreLocator.prototype.getTargetObject("uid", objId.split("Zoom")[0]);
		slObj.MAP.setZoomLevel(slObj.MAP.getZoomLevel() < 18 ? slObj.MAP.getZoomLevel() + 1 : 18);
	},
	zoomOut: function(){
		var objId = StoreLocator.prototype.getObjectId(this);
		var slObj = objId == null ? this : StoreLocator.prototype.getTargetObject("uid", objId.split("Zoom")[0]);
		slObj.MAP.setZoomLevel(slObj.MAP.getZoomLevel() > 2 ? slObj.MAP.getZoomLevel() - 1 : 2);
	},
	mapquestModuleLoaded: function(){
		return true;
	}
}, "StoreLocator.prototype.mapModuleLoaded", "mapquest");
